scinetcdf_path = getSciNetCDFPath();
exec(fullfile(scinetcdf_path, "tests/test_utils.sci"));

[ret, ncid] = nc_open(fullfile(scinetcdf_path, "tests/nonreg_tests/data/simple_nc4.nc"), NC_NOWRITE);
assert_checkreturn(ret, 0, "nc_open(...)");

SIZE = 6 * 12;

[ret, grp1id] = nc_inq_grp_ncid(ncid, "grp1");
assert_checkreturn(ret, 0, "nc_inq_grp_ncid(ncid, ""grp1"")");
[ret, var1id] = nc_inq_varid(grp1id, "data");
assert_checkreturn(ret, 0, "nc_inq_varid(grp1id, ...)");

dataIn = new_IntArray(SIZE);
ret = nc_get_var_int(grp1id, var1id, dataIn);
assert_checkreturn(ret, 0, "nc_get_var_int(grp1id, ...)");
dataInt_mat = [];
for i=0:SIZE-1
  dataInt_mat($+1) = IntArray_getitem(dataIn, i);
end
assert_checkequal(dataInt_mat, [0:SIZE-1]');
delete_IntArray(dataIn);

[ret, grp2id] = nc_inq_grp_ncid(ncid, "grp2");
assert_checkreturn(ret, 0, "nc_inq_grp_ncid(ncid, ""grp2"")");
[ret, var2id] = nc_inq_varid(grp2id, "data");
assert_checkreturn(ret, 0, "nc_inq_varid(grp2id, ...)");

compound_data = new_IntArray(SIZE * 2);
ret = nc_get_var(grp2id, var2id, compound_data);
assert_checkreturn(ret, 0, "nc_get_var(grp2id, ...)");
compound_data_mat = [];
for i=0:2*SIZE-1
  compound_data_mat($+1) = IntArray_getitem(compound_data, i);
end
assert_checkequal(compound_data_mat, repmat([42; -42], SIZE, 1));
delete_IntArray(compound_data);

ret = nc_close(ncid);
assert_checkreturn(ret, 0, "nc_close(...)");
